diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/shift-run-template.h b/gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/shift-run-template.h
similarity index 100%
rename from gcc/testsuite/gcc.target/riscv/rvv/autovec/shift-run-template.h
rename to gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/shift-run-template.h
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/shift-run.c b/gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/shift-run.c
similarity index 100%
rename from gcc/testsuite/gcc.target/riscv/rvv/autovec/shift-run.c
rename to gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/shift-run.c
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/shift-rv32gcv.c b/gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/shift-rv32gcv.c
similarity index 100%
rename from gcc/testsuite/gcc.target/riscv/rvv/autovec/shift-rv32gcv.c
rename to gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/shift-rv32gcv.c
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/shift-rv64gcv.c b/gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/shift-rv64gcv.c
similarity index 100%
rename from gcc/testsuite/gcc.target/riscv/rvv/autovec/shift-rv64gcv.c
rename to gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/shift-rv64gcv.c
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/shift-scalar-run.c b/gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/shift-scalar-run.c
similarity index 100%
rename from gcc/testsuite/gcc.target/riscv/rvv/autovec/shift-scalar-run.c
rename to gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/shift-scalar-run.c
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/shift-scalar-rv32gcv.c b/gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/shift-scalar-rv32gcv.c
similarity index 100%
rename from gcc/testsuite/gcc.target/riscv/rvv/autovec/shift-scalar-rv32gcv.c
rename to gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/shift-scalar-rv32gcv.c
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/shift-scalar-rv64gcv.c b/gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/shift-scalar-rv64gcv.c
similarity index 100%
rename from gcc/testsuite/gcc.target/riscv/rvv/autovec/shift-scalar-rv64gcv.c
rename to gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/shift-scalar-rv64gcv.c
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/shift-scalar-template.h b/gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/shift-scalar-template.h
similarity index 100%
rename from gcc/testsuite/gcc.target/riscv/rvv/autovec/shift-scalar-template.h
rename to gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/shift-scalar-template.h
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/shift-template.h b/gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/shift-template.h
similarity index 100%
rename from gcc/testsuite/gcc.target/riscv/rvv/autovec/shift-template.h
rename to gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/shift-template.h
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/vadd-run-template.h b/gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vadd-run-template.h
similarity index 100%
rename from gcc/testsuite/gcc.target/riscv/rvv/autovec/vadd-run-template.h
rename to gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vadd-run-template.h
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/vadd-run.c b/gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vadd-run.c
similarity index 100%
rename from gcc/testsuite/gcc.target/riscv/rvv/autovec/vadd-run.c
rename to gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vadd-run.c
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/vadd-rv32gcv.c b/gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vadd-rv32gcv.c
similarity index 100%
rename from gcc/testsuite/gcc.target/riscv/rvv/autovec/vadd-rv32gcv.c
rename to gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vadd-rv32gcv.c
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/vadd-rv64gcv.c b/gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vadd-rv64gcv.c
similarity index 100%
rename from gcc/testsuite/gcc.target/riscv/rvv/autovec/vadd-rv64gcv.c
rename to gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vadd-rv64gcv.c
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/vadd-template.h b/gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vadd-template.h
similarity index 100%
rename from gcc/testsuite/gcc.target/riscv/rvv/autovec/vadd-template.h
rename to gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vadd-template.h
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/vand-run-template.h b/gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vand-run-template.h
similarity index 100%
rename from gcc/testsuite/gcc.target/riscv/rvv/autovec/vand-run-template.h
rename to gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vand-run-template.h
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/vand-run.c b/gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vand-run.c
similarity index 100%
rename from gcc/testsuite/gcc.target/riscv/rvv/autovec/vand-run.c
rename to gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vand-run.c
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/vand-rv32gcv.c b/gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vand-rv32gcv.c
similarity index 100%
rename from gcc/testsuite/gcc.target/riscv/rvv/autovec/vand-rv32gcv.c
rename to gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vand-rv32gcv.c
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/vand-rv64gcv.c b/gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vand-rv64gcv.c
similarity index 100%
rename from gcc/testsuite/gcc.target/riscv/rvv/autovec/vand-rv64gcv.c
rename to gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vand-rv64gcv.c
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/vand-template.h b/gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vand-template.h
similarity index 100%
rename from gcc/testsuite/gcc.target/riscv/rvv/autovec/vand-template.h
rename to gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vand-template.h
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/vdiv-run-template.h b/gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vdiv-run-template.h
similarity index 100%
rename from gcc/testsuite/gcc.target/riscv/rvv/autovec/vdiv-run-template.h
rename to gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vdiv-run-template.h
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/vdiv-run.c b/gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vdiv-run.c
similarity index 100%
rename from gcc/testsuite/gcc.target/riscv/rvv/autovec/vdiv-run.c
rename to gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vdiv-run.c
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/vdiv-rv32gcv.c b/gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vdiv-rv32gcv.c
similarity index 100%
rename from gcc/testsuite/gcc.target/riscv/rvv/autovec/vdiv-rv32gcv.c
rename to gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vdiv-rv32gcv.c
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/vdiv-rv64gcv.c b/gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vdiv-rv64gcv.c
similarity index 100%
rename from gcc/testsuite/gcc.target/riscv/rvv/autovec/vdiv-rv64gcv.c
rename to gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vdiv-rv64gcv.c
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/vdiv-template.h b/gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vdiv-template.h
similarity index 100%
rename from gcc/testsuite/gcc.target/riscv/rvv/autovec/vdiv-template.h
rename to gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vdiv-template.h
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/vmax-run-template.h b/gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vmax-run-template.h
similarity index 100%
rename from gcc/testsuite/gcc.target/riscv/rvv/autovec/vmax-run-template.h
rename to gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vmax-run-template.h
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/vmax-run.c b/gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vmax-run.c
similarity index 100%
rename from gcc/testsuite/gcc.target/riscv/rvv/autovec/vmax-run.c
rename to gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vmax-run.c
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/vmax-rv32gcv.c b/gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vmax-rv32gcv.c
similarity index 100%
rename from gcc/testsuite/gcc.target/riscv/rvv/autovec/vmax-rv32gcv.c
rename to gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vmax-rv32gcv.c
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/vmax-rv64gcv.c b/gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vmax-rv64gcv.c
similarity index 100%
rename from gcc/testsuite/gcc.target/riscv/rvv/autovec/vmax-rv64gcv.c
rename to gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vmax-rv64gcv.c
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/vmax-template.h b/gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vmax-template.h
similarity index 100%
rename from gcc/testsuite/gcc.target/riscv/rvv/autovec/vmax-template.h
rename to gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vmax-template.h
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/vmin-run-template.h b/gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vmin-run-template.h
similarity index 100%
rename from gcc/testsuite/gcc.target/riscv/rvv/autovec/vmin-run-template.h
rename to gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vmin-run-template.h
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/vmin-run.c b/gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vmin-run.c
similarity index 100%
rename from gcc/testsuite/gcc.target/riscv/rvv/autovec/vmin-run.c
rename to gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vmin-run.c
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/vmin-rv32gcv.c b/gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vmin-rv32gcv.c
similarity index 100%
rename from gcc/testsuite/gcc.target/riscv/rvv/autovec/vmin-rv32gcv.c
rename to gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vmin-rv32gcv.c
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/vmin-rv64gcv.c b/gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vmin-rv64gcv.c
similarity index 100%
rename from gcc/testsuite/gcc.target/riscv/rvv/autovec/vmin-rv64gcv.c
rename to gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vmin-rv64gcv.c
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/vmin-template.h b/gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vmin-template.h
similarity index 100%
rename from gcc/testsuite/gcc.target/riscv/rvv/autovec/vmin-template.h
rename to gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vmin-template.h
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/vmul-run-template.h b/gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vmul-run-template.h
similarity index 100%
rename from gcc/testsuite/gcc.target/riscv/rvv/autovec/vmul-run-template.h
rename to gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vmul-run-template.h
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/vmul-run.c b/gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vmul-run.c
similarity index 100%
rename from gcc/testsuite/gcc.target/riscv/rvv/autovec/vmul-run.c
rename to gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vmul-run.c
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/vmul-rv32gcv.c b/gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vmul-rv32gcv.c
similarity index 100%
rename from gcc/testsuite/gcc.target/riscv/rvv/autovec/vmul-rv32gcv.c
rename to gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vmul-rv32gcv.c
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/vmul-rv64gcv.c b/gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vmul-rv64gcv.c
similarity index 100%
rename from gcc/testsuite/gcc.target/riscv/rvv/autovec/vmul-rv64gcv.c
rename to gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vmul-rv64gcv.c
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/vmul-template.h b/gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vmul-template.h
similarity index 100%
rename from gcc/testsuite/gcc.target/riscv/rvv/autovec/vmul-template.h
rename to gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vmul-template.h
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/vor-run-template.h b/gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vor-run-template.h
similarity index 100%
rename from gcc/testsuite/gcc.target/riscv/rvv/autovec/vor-run-template.h
rename to gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vor-run-template.h
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/vor-run.c b/gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vor-run.c
similarity index 100%
rename from gcc/testsuite/gcc.target/riscv/rvv/autovec/vor-run.c
rename to gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vor-run.c
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/vor-rv32gcv.c b/gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vor-rv32gcv.c
similarity index 100%
rename from gcc/testsuite/gcc.target/riscv/rvv/autovec/vor-rv32gcv.c
rename to gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vor-rv32gcv.c
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/vor-rv64gcv.c b/gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vor-rv64gcv.c
similarity index 100%
rename from gcc/testsuite/gcc.target/riscv/rvv/autovec/vor-rv64gcv.c
rename to gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vor-rv64gcv.c
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/vor-template.h b/gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vor-template.h
similarity index 100%
rename from gcc/testsuite/gcc.target/riscv/rvv/autovec/vor-template.h
rename to gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vor-template.h
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/vrem-run-template.h b/gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vrem-run-template.h
similarity index 100%
rename from gcc/testsuite/gcc.target/riscv/rvv/autovec/vrem-run-template.h
rename to gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vrem-run-template.h
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/vrem-run.c b/gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vrem-run.c
similarity index 100%
rename from gcc/testsuite/gcc.target/riscv/rvv/autovec/vrem-run.c
rename to gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vrem-run.c
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/vrem-rv32gcv.c b/gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vrem-rv32gcv.c
similarity index 100%
rename from gcc/testsuite/gcc.target/riscv/rvv/autovec/vrem-rv32gcv.c
rename to gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vrem-rv32gcv.c
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/vrem-rv64gcv.c b/gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vrem-rv64gcv.c
similarity index 100%
rename from gcc/testsuite/gcc.target/riscv/rvv/autovec/vrem-rv64gcv.c
rename to gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vrem-rv64gcv.c
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/vrem-template.h b/gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vrem-template.h
similarity index 100%
rename from gcc/testsuite/gcc.target/riscv/rvv/autovec/vrem-template.h
rename to gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vrem-template.h
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/vsub-run-template.h b/gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vsub-run-template.h
similarity index 100%
rename from gcc/testsuite/gcc.target/riscv/rvv/autovec/vsub-run-template.h
rename to gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vsub-run-template.h
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/vsub-run.c b/gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vsub-run.c
similarity index 100%
rename from gcc/testsuite/gcc.target/riscv/rvv/autovec/vsub-run.c
rename to gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vsub-run.c
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/vsub-rv32gcv.c b/gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vsub-rv32gcv.c
similarity index 100%
rename from gcc/testsuite/gcc.target/riscv/rvv/autovec/vsub-rv32gcv.c
rename to gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vsub-rv32gcv.c
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/vsub-rv64gcv.c b/gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vsub-rv64gcv.c
similarity index 100%
rename from gcc/testsuite/gcc.target/riscv/rvv/autovec/vsub-rv64gcv.c
rename to gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vsub-rv64gcv.c
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/vsub-template.h b/gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vsub-template.h
similarity index 100%
rename from gcc/testsuite/gcc.target/riscv/rvv/autovec/vsub-template.h
rename to gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vsub-template.h
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/vxor-run-template.h b/gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vxor-run-template.h
similarity index 100%
rename from gcc/testsuite/gcc.target/riscv/rvv/autovec/vxor-run-template.h
rename to gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vxor-run-template.h
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/vxor-run.c b/gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vxor-run.c
similarity index 100%
rename from gcc/testsuite/gcc.target/riscv/rvv/autovec/vxor-run.c
rename to gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vxor-run.c
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/vxor-rv32gcv.c b/gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vxor-rv32gcv.c
similarity index 100%
rename from gcc/testsuite/gcc.target/riscv/rvv/autovec/vxor-rv32gcv.c
rename to gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vxor-rv32gcv.c
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/vxor-rv64gcv.c b/gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vxor-rv64gcv.c
similarity index 100%
rename from gcc/testsuite/gcc.target/riscv/rvv/autovec/vxor-rv64gcv.c
rename to gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vxor-rv64gcv.c
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/vxor-template.h b/gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vxor-template.h
similarity index 100%
rename from gcc/testsuite/gcc.target/riscv/rvv/autovec/vxor-template.h
rename to gcc/testsuite/gcc.target/riscv/rvv/autovec/binop/vxor-template.h
diff --git a/gcc/testsuite/gcc.target/riscv/rvv/rvv.exp b/gcc/testsuite/gcc.target/riscv/rvv/rvv.exp
index 0eef068058a..be2457fbd99 100644
--- a/gcc/testsuite/gcc.target/riscv/rvv/rvv.exp
+++ b/gcc/testsuite/gcc.target/riscv/rvv/rvv.exp
@@ -61,6 +61,8 @@ set AUTOVEC_TEST_OPTS [list \
 foreach op $AUTOVEC_TEST_OPTS {
   dg-runtest [lsort [glob -nocomplain $srcdir/$subdir/autovec/partial/*.\[cS\]]] \
     "" "$op"
+  dg-runtest [lsort [glob -nocomplain $srcdir/$subdir/autovec/binop/*.\[cS\]]] \
+    "" "$op"
 }
 
 # All done.